import java.util.ArrayList;
import java.util.List;

/*******************************************************************************
 * Testovac tda PersonListTest slou ke komplexnmu otestovn
 * tdy ...
 *
 * @author    Tom Pitner
 * @version   1.00, 10.8.2005
 */
public class PersonListTest extends junit.framework.TestCase {

    private List<Person> personList;
    
    private Person me;

    private Person you;

    private Person he;

    private Person she;

    /***************************************************************************
     * Vytvo test se zadanm nzvem.
     *
     * @param nzev  Nzev konstruovanho testu
     */
    public PersonListTest(String nazev) {
        super( nazev );
    }



//== PPRAVA A KLID PPRAVKU ===============================================

    /***************************************************************************
     * Vytvoen ppravku (fixture), tj. sady objekt, s nimi budou vechny
     * testy pracovat a kter se proto vytvo ped sputnm kadho testu.         
     */
    protected void setUp() {
        personList = new ArrayList<Person>();
        
        me = new Person("Jan Novak", 30);
        you = new Person("Pavel Horak", 20);
        he = new Person("Libor Polak", 55);
        she = new Person("Anita Polakova", 51);
        
        personList.add(me);
        personList.add(you);
        personList.add(he);
    }

    /***************************************************************************
     * klid po testu - tato metoda se spust po vykonn kadho testu.
     */
    protected void tearDown() {
    }


//== VLASTN TESTY =============================================================

    /***************************************************************************
     * Je 'he' na pozici 2?
     */
    public void testPersonPresent() {
        assertEquals("He should be at position 2.", 2, personList.indexOf(he));
    }

    /***************************************************************************
     * 'she' by nemla v seznamu bt.
     */
    public void testPersonNotPresent() {
        assertEquals("Her position should be -1 (not in the List).", -1, personList.indexOf(she));
    }

    /***************************************************************************
     * 'you' by po vymazn neml v seznamu bt.
     */
    public void testPersonDeletedNotPresent() {
        personList.remove(1);
        assertEquals("Your position should now be -1 (not in the List).", 
            -1, personList.indexOf(you));
    }

    /***************************************************************************
     * 'you' by po vymazn neml v seznamu bt.
     */
    public void testPersonDeletedInsertedPresent() {
        personList.remove(1);
        personList.add(0, you);
        assertEquals("Your position should now be 0.", 0, personList.indexOf(you));
    }

    /***************************************************************************
     * 
     */
    public void testPersonDeletedInsertedGet() {
        personList.remove(1);
        personList.add(0, you);
        assertEquals("At first position should be 'me'.", me, personList.get(1));
    }

}
